/* RAW socket utility routine:
 * 
 * Write out a TCP header.
 * shadows@whitefang.com
 * Thamer Al-Herbish
 */

#include <stdlib.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netinet/in_systm.h>

#include <linux/tcp.h>

#include <unistd.h>
#include <string.h>

#define TH_OFFSET 5

#define TCP_WINDOW_SIZE 16200 /* Just have it hardcoded. */

void tcp_gens(char *packet, unsigned short sport, unsigned short dport,
	      unsigned long seq, unsigned long ack,
	      char b_ack, char *option, int optlen)
{
  struct tcphdr *tcp;
  
  tcp = (struct tcphdr *)packet;
  memset((char *)tcp, 0, sizeof(struct tcphdr));

  tcp->source = htons(sport);
  tcp->dest = htons(dport);
  
  tcp->seq = htonl(seq);
  tcp->ack_seq = htonl(ack);
  
  tcp->res1 = 0;
  tcp->doff = TH_OFFSET + (optlen + 3) / 4;
  tcp->window = htons(TCP_WINDOW_SIZE);

  tcp->fin = 0;
  tcp->ack = b_ack;
  tcp->rst = 0;
  tcp->psh = 0;
  tcp->syn = 1;

  if (option != NULL && optlen > 0)
    memcpy(packet + sizeof(struct tcphdr), option, optlen);

  return;
}

void tcp_genx(char *packet,unsigned short sport, unsigned short dport,
	      unsigned long seq, unsigned long ack,
	      char b_ack, char b_fin, char b_psh)
{
  struct tcphdr *tcp;
  
  tcp = (struct tcphdr *)packet;
  memset((char *)tcp, 0, sizeof(struct tcphdr));

  tcp->source = htons(sport);
  tcp->dest = htons(dport);
  
  tcp->seq = htonl(seq);
  tcp->ack_seq = htonl(ack);
  
  tcp->res1 = 0;
  tcp->doff = TH_OFFSET;
  tcp->window = htons(TCP_WINDOW_SIZE);

  tcp->fin = b_fin;
  tcp->ack = b_ack;
  tcp->rst = 0;
  tcp->psh = b_psh;
  tcp->syn = 0;
}

void tcp_gen(char *packet,unsigned short sport,
	     unsigned short dport,unsigned long seq,
	     unsigned long ack)
{
  tcp_genx(packet, sport, dport, seq, ack, 1, 1, 0);
}
